// Fill out your copyright notice in the Description page of Project Settings.

#include "MyUnrealPrj.h"
#include "MyLicenseCheckerExample.h"
#include "../../../Plugins/ViveportLicenseChecker/Source/ViveportLicenseChecker/Public/ViveportLicenseChecker.h"


// Sets default values for this component's properties
UMyLicenseCheckerExample::UMyLicenseCheckerExample() : mLicenseChecker(0)
{
	UE_LOG(LogTemp, Display, TEXT("(%p) UMyLicenseCheckerExample::UMyLicenseCheckerExample()"), this);	

	// Set this component to be initialized when the game starts, and to be ticked every frame.  You can turn these features
	// off to improve performance if you don't need them.
	bWantsBeginPlay = true;
	PrimaryComponentTick.bCanEverTick = true;

	// ...	

	// Test Id and Test Key. All users will be allowed to use your app.
	const char* viveportID = "bd67b286-aafc-449d-8896-bb7e9b351876";
	const char* viveportKey = "MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDFypCg0OHfBC+VZLSWPbNSgDo9qg/yQORDwGy1rKIboMj3IXn4Zy6h6bgn8kiMY7VI0lPwIj9lijT3ZxkzuTsI5GsK//Y1bqeTol4OUFR+47gj+TUuekAS2WMtglKox+/7mO6CA1gV+jZrAKo6YSVmPd+oFsgisRcqEgNh5MIURQIDAQAB";

	// use your Id & Key from developer console. It could be used to test DENY_NOT_LICENSED if the account on the testing device does not own the App.
	//const char* viveportID = "f6156ae3-dfae-4adb-bcaa-356a3eba04cc";
	//const char* viveportKey = "MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQC+VjnuDIAJoGu3dvOo9it+ph8zgIQSvRSJcVB29WbOkKKqKZk57bQWo4UjR+5YPbipSVC6EHRtHT9/y0KAg355/JvGNY8+rXXDHEuhON2frufQwnUT8KUjkmPd4LA1BTHnO6S+GOdN40AesTeBZgwacmXHzxTIbyCgNZuHsPkxZwIDAQAB";

	mLicenseChecker = new ViveportLicenseChecker(viveportID, viveportKey);	
	ViveportLicenseChecker::Results r = mLicenseChecker->GetResult();
	UE_LOG(LogTemp, Display, TEXT("(%p) new ViveportLicenseChecker --> result= %d"), this, r);
}


// Called when the game starts
void UMyLicenseCheckerExample::BeginPlay()
{	
	Super::BeginPlay();
	// ...		

	mLicenseChecker->ClearCache(); // for test only
	mLicenseChecker->CheckAccess();
	ViveportLicenseChecker::Results r = mLicenseChecker->GetResult();	
	UE_LOG(LogTemp, Display, TEXT("(%p) CheckAccess() --> result= %d"), this, r);
}


// Called every frame
void UMyLicenseCheckerExample::TickComponent( float DeltaTime, ELevelTick TickType, FActorComponentTickFunction* ThisTickFunction )
{
	Super::TickComponent( DeltaTime, TickType, ThisTickFunction );
	// ...

	if (mLicenseChecker)
	{
		ViveportLicenseChecker::Results r = mLicenseChecker->GetResult();		
		if(r!= ViveportLicenseChecker::CHECK_IN_PROGRESS)
		{
			UE_LOG(LogTemp, Display, TEXT("(%p) mLicenseChecker->GetResult() = %d"), this, r);
			delete mLicenseChecker;
			mLicenseChecker = 0;
		}		
	}
	
}

void UMyLicenseCheckerExample::BeginDestroy()
{	
	UE_LOG(LogTemp, Display, TEXT("(%p) UMyLicenseCheckerExample::BeginDestroy()"), this);	
}


UMyLicenseCheckerExample::~UMyLicenseCheckerExample()
{
	UE_LOG(LogTemp, Display, TEXT("(%p) UMyLicenseCheckerExample::~UMyLicenseCheckerExample()"), this);	

	if (mLicenseChecker)
		delete mLicenseChecker;	
}